Hyang-Ah Hana Kim | 92189a2 | 2015-04-16 13:46:58 -0400 | [diff] [blame] | 1 | #!/usr/bin/env bash |
| 2 | # Copyright 2015 The Go Authors. All rights reserved. |
| 3 | # Use of this source code is governed by a BSD-style |
| 4 | # license that can be found in the LICENSE file. |
| 5 | |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 6 | # For testing Android, this script requires adb to push and run compiled |
| 7 | # binaries on a target device. |
| 8 | |
Hyang-Ah Hana Kim | 92189a2 | 2015-04-16 13:46:58 -0400 | [diff] [blame] | 9 | set -e |
| 10 | |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 11 | if [ ! -f src/libgo/libgo.go ]; then |
| 12 | cwd=$(pwd) |
| 13 | echo 'misc/cgo/testcshared/test.bash is running in $cwd' 1>&2 |
| 14 | exit 1 |
| 15 | fi |
| 16 | |
| 17 | goos=$(go env GOOS) |
Hyang-Ah (Hana) Kim | a4f4a46 | 2015-05-12 16:47:40 -0400 | [diff] [blame] | 18 | goarch=$(go env GOARCH) |
| 19 | |
| 20 | # Directory where cgo headers and outputs will be installed. |
| 21 | # The installation directory format varies depending on the platform. |
| 22 | installdir=pkg/${goos}_${goarch}_testcshared_shared |
Srdjan Petrovic | cc6554f | 2015-06-16 10:07:45 -0700 | [diff] [blame] | 23 | if [ "${goos}/${goarch}" == "android/arm" ] || [ "${goos}/${goarch}" == "darwin/amd64" ]; then |
Hyang-Ah (Hana) Kim | a4f4a46 | 2015-05-12 16:47:40 -0400 | [diff] [blame] | 24 | installdir=pkg/${goos}_${goarch}_testcshared |
| 25 | fi |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 26 | |
| 27 | # Temporary directory on the android device. |
| 28 | androidpath=/data/local/tmp/testcshared-$$ |
| 29 | |
Hyang-Ah Hana Kim | 92189a2 | 2015-04-16 13:46:58 -0400 | [diff] [blame] | 30 | function cleanup() { |
Mikio Hara | fe1cecf | 2015-06-25 11:33:48 +0900 | [diff] [blame] | 31 | rm -rf libgo.$libext libgo2.$libext libgo.h testp testp2 testp3 pkg |
Ian Lance Taylor | e45aebd | 2015-05-06 22:06:19 -0700 | [diff] [blame] | 32 | |
Hyang-Ah (Hana) Kim | a4f4a46 | 2015-05-12 16:47:40 -0400 | [diff] [blame] | 33 | rm -rf $(go env GOROOT)/${installdir} |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 34 | |
Hyang-Ah (Hana) Kim | a4f4a46 | 2015-05-12 16:47:40 -0400 | [diff] [blame] | 35 | if [ "$goos" == "android" ]; then |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 36 | adb shell rm -rf $androidpath |
| 37 | fi |
Hyang-Ah Hana Kim | 92189a2 | 2015-04-16 13:46:58 -0400 | [diff] [blame] | 38 | } |
| 39 | trap cleanup EXIT |
| 40 | |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 41 | if [ "$goos" == "android" ]; then |
| 42 | adb shell mkdir -p "$androidpath" |
| 43 | fi |
| 44 | |
| 45 | function run() { |
| 46 | case "$goos" in |
| 47 | "android") |
| 48 | local args=$@ |
Hyang-Ah (Hana) Kim | 647026a | 2015-05-13 17:26:19 -0400 | [diff] [blame] | 49 | output=$(adb shell "cd ${androidpath}; $@") |
Hyang-Ah (Hana) Kim | a4f4a46 | 2015-05-12 16:47:40 -0400 | [diff] [blame] | 50 | output=$(echo $output|tr -d '\r') |
Hyang-Ah Hana Kim | e9a89b8 | 2015-04-24 14:11:29 -0400 | [diff] [blame] | 51 | case $output in |
| 52 | *PASS) echo "PASS";; |
| 53 | *) echo "$output";; |
| 54 | esac |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 55 | ;; |
| 56 | *) |
| 57 | echo $(env $@) |
| 58 | ;; |
| 59 | esac |
| 60 | } |
| 61 | |
| 62 | function binpush() { |
| 63 | bin=${1} |
| 64 | if [ "$goos" == "android" ]; then |
| 65 | adb push "$bin" "${androidpath}/${bin}" 2>/dev/null |
| 66 | fi |
| 67 | } |
| 68 | |
Ian Lance Taylor | e45aebd | 2015-05-06 22:06:19 -0700 | [diff] [blame] | 69 | rm -rf pkg |
| 70 | |
| 71 | suffix="-installsuffix testcshared" |
| 72 | |
Srdjan Petrovic | cc6554f | 2015-06-16 10:07:45 -0700 | [diff] [blame] | 73 | libext="so" |
| 74 | if [ "$goos" == "darwin" ]; then |
| 75 | libext="dylib" |
| 76 | fi |
| 77 | |
Ian Lance Taylor | e45aebd | 2015-05-06 22:06:19 -0700 | [diff] [blame] | 78 | # Create the header files. |
| 79 | GOPATH=$(pwd) go install -buildmode=c-shared $suffix libgo |
| 80 | |
Srdjan Petrovic | cc6554f | 2015-06-16 10:07:45 -0700 | [diff] [blame] | 81 | GOPATH=$(pwd) go build -buildmode=c-shared $suffix -o libgo.$libext src/libgo/libgo.go |
| 82 | binpush libgo.$libext |
Hyang-Ah Hana Kim | 92189a2 | 2015-04-16 13:46:58 -0400 | [diff] [blame] | 83 | |
Michael Hudson-Doyle | 2c2cbb6 | 2015-05-21 13:07:19 +1200 | [diff] [blame^] | 84 | if [ "$goos" == "linux" ]; then |
| 85 | if readelf -d libgo.$libext | grep TEXTREL >/dev/null; then |
| 86 | echo "libgo.$libext has TEXTREL set" |
| 87 | exit 1 |
| 88 | fi |
| 89 | fi |
| 90 | |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 91 | # test0: exported symbols in shared lib are accessible. |
Ian Lance Taylor | e45aebd | 2015-05-06 22:06:19 -0700 | [diff] [blame] | 92 | # TODO(iant): using _shared here shouldn't really be necessary. |
Srdjan Petrovic | cc6554f | 2015-06-16 10:07:45 -0700 | [diff] [blame] | 93 | $(go env CC) $(go env GOGCCFLAGS) -I ${installdir} -o testp main0.c libgo.$libext |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 94 | binpush testp |
Hyang-Ah (Hana) Kim | a4f4a46 | 2015-05-12 16:47:40 -0400 | [diff] [blame] | 95 | |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 96 | output=$(run LD_LIBRARY_PATH=. ./testp) |
Hyang-Ah Hana Kim | 92189a2 | 2015-04-16 13:46:58 -0400 | [diff] [blame] | 97 | if [ "$output" != "PASS" ]; then |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 98 | echo "FAIL test0 got ${output}" |
Hyang-Ah Hana Kim | 92189a2 | 2015-04-16 13:46:58 -0400 | [diff] [blame] | 99 | exit 1 |
| 100 | fi |
| 101 | |
Srdjan Petrovic | cc6554f | 2015-06-16 10:07:45 -0700 | [diff] [blame] | 102 | # test1: shared library can be dynamically loaded and exported symbols are accessible. |
Hyang-Ah Hana Kim | 92189a2 | 2015-04-16 13:46:58 -0400 | [diff] [blame] | 103 | $(go env CC) $(go env GOGCCFLAGS) -o testp main1.c -ldl |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 104 | binpush testp |
Srdjan Petrovic | cc6554f | 2015-06-16 10:07:45 -0700 | [diff] [blame] | 105 | output=$(run ./testp ./libgo.$libext) |
Hyang-Ah Hana Kim | 92189a2 | 2015-04-16 13:46:58 -0400 | [diff] [blame] | 106 | if [ "$output" != "PASS" ]; then |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 107 | echo "FAIL test1 got ${output}" |
Hyang-Ah Hana Kim | 92189a2 | 2015-04-16 13:46:58 -0400 | [diff] [blame] | 108 | exit 1 |
| 109 | fi |
Ian Lance Taylor | e589e08 | 2015-04-21 10:46:29 -0700 | [diff] [blame] | 110 | |
Srdjan Petrovic | cc6554f | 2015-06-16 10:07:45 -0700 | [diff] [blame] | 111 | # test2: tests libgo2 which does not export any functions. |
| 112 | GOPATH=$(pwd) go build -buildmode=c-shared $suffix -o libgo2.$libext src/libgo2/libgo2.go |
| 113 | binpush libgo2.$libext |
| 114 | linkflags="-Wl,--no-as-needed" |
| 115 | if [ "$goos" == "darwin" ]; then |
| 116 | linkflags="" |
| 117 | fi |
| 118 | $(go env CC) $(go env GOGCCFLAGS) -o testp2 main2.c $linkflags libgo2.$libext |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 119 | binpush testp2 |
| 120 | output=$(run LD_LIBRARY_PATH=. ./testp2) |
Ian Lance Taylor | e589e08 | 2015-04-21 10:46:29 -0700 | [diff] [blame] | 121 | if [ "$output" != "PASS" ]; then |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 122 | echo "FAIL test2 got ${output}" |
Ian Lance Taylor | e589e08 | 2015-04-21 10:46:29 -0700 | [diff] [blame] | 123 | exit 1 |
| 124 | fi |
Hyang-Ah Hana Kim | 8566979 | 2015-04-23 17:27:38 -0400 | [diff] [blame] | 125 | |
| 126 | # test3: tests main.main is exported on android. |
| 127 | if [ "$goos" == "android" ]; then |
| 128 | $(go env CC) $(go env GOGCCFLAGS) -o testp3 main3.c -ldl |
| 129 | binpush testp3 |
| 130 | output=$(run ./testp ./libgo.so) |
| 131 | if [ "$output" != "PASS" ]; then |
| 132 | echo "FAIL test3 got ${output}" |
| 133 | exit 1 |
| 134 | fi |
| 135 | fi |
| 136 | echo "ok" |